var story = new Array(1200);
var storyB = new Array(1200);
var action = new Array(1200);
var actionB = new Array(1200);
var actionRepeat = new Array(1200);

/*****player info************/
const skills = new Map();
var debug = false; var cheat = false; // if you change that you may break your save be carefull!!
if(debug && cheat){
  skills.set("adaptationSkillLevel", 30);
  skills.set("magicSkillLevel", 30);
  skills.set("constructionSkillLevel", 30);
  skills.set("fightingSkillLevel", 30);
}else{
  skills.set("adaptationSkillLevel", 1);
  skills.set("magicSkillLevel", 1);
  skills.set("constructionSkillLevel", 1);
  skills.set("fightingSkillLevel", 1);
  if(localStorage.getItem("adaptationSkillLevel")!= null)
    skills.set("adaptationSkillLevel", parseFloat(localStorage.getItem("adaptationSkillLevel")));
  if(localStorage.getItem("magicSkillLevel")!= null)
    skills.set("magicSkillLevel", parseFloat(localStorage.getItem("magicSkillLevel")));
  if(localStorage.getItem("constructionSkillLevel")!= null)
    skills.set("constructionSkillLevel", parseFloat(localStorage.getItem("constructionSkillLevel")));
  if(localStorage.getItem("fightingSkillLevel")!= null)
    skills.set("fightingSkillLevel", parseFloat(localStorage.getItem("fightingSkillLevel")));
}

function updateSkillDisplay() {
  // Define an array of skill names
  const skillNames = ["Adaptation", "Magic", "Construction", "Fighting"];

  // Loop through each skill name and update the corresponding div
  skillNames.forEach(function (skillName) {
    let skillDivs = document.querySelectorAll('.' + skillName + 'Div');
    skillDivs.forEach(function (skillDiv) {
      const skillLevel = skills.get(skillName.toLowerCase() + "SkillLevel");
      const skillArmy = getSkillArmy(skillName);
      const skillTotal = skillLevel * skillArmy;

      skillDiv.innerHTML = skillName + "Skill : " + Math.round(skillLevel * 100) / 100 + " * " + Math.round(skillArmy*100)/100 + " = " + (Math.round(skillTotal * 100) / 100);
    });
  });
}

function getSkillArmy(skillName) {
  switch (skillName) {
    case "Adaptation":
      return 1 + troops[mindlessSlaveId] * 0.05;
    case "Magic":
      return 1;
    case "Construction":
      return 1 + troops[droneId] * 0.2 + troops[mindlessSlaveId] * 0.05;
    case "Fighting":
      let res = 1 + troops[maskedId] * 0.2;
      res += troops[droneId] * 0.05;
      return res;
    default:
      return 1; // Default value if skillName is not recognized
  }
}


var mana; var manaMax;
var notoriety;
var notorietyMax;
var isGameOver = false;
var nextWave;

var pronoun ="she";
var title = "mistress";
var playerName;
  /**Gender and info***********/
var askPlayerName = function(){ let answer = prompt("Please enter your name", "Kai");
if (answer == null || answer == "") {
 playerName = "Kai";
} else {
  playerName = answer;
} 
storyB[17] = "I pretend I'm a traveler named "+playerName+" and I've just come across a carriage that's been attacked, intentionally forgetting to mention anything that might make her understand that I was one of its passengers.</br>She insists I take her to the cart. After inspection, she asks me to follow her into the forest, she seems to be following a trail...";
}
  /**end gender*******/

/***********TABS**************/
const tabs = document.querySelectorAll('[data-tab-value]')
const tabInfos = document.querySelectorAll('[data-tab-info]')

tabs.forEach(tab => {//change selected tab when clicked
  tab.addEventListener('click', () => {
    const target = document.querySelector(tab.dataset.tabValue);

    tabInfos.forEach(tabInfo => {
      tabInfo.classList.remove('active')
    })
    target.classList.add('active');
  })
})   

/*******************************/
/***********inventory************/
var items = new Array(3);

function updateInventoryDisplay() {
  const inventoryDivs = document.querySelectorAll('.inventoryDiv');
  
  inventoryDivs.forEach((inventory) => {
    inventory.innerHTML = "Inventory :";
    items.forEach(updateInventoryElement);
    
    function updateInventoryElement(el, index) {
      if (items[index] != 0) {
        inventory.innerHTML += "</br>" + itemNames[index] + " : " + items[index];
      }
    }
  });
}
function emptyInventorySlot(element, index, array){
  items[index]=0;
}
  /***********ID table***********/
var itemNames = new Array(3);
const maskId = 0; itemNames[0]="mask"; items[maskId]=0;
const scrollPuppetId = 1; itemNames[1]= "scroll of puppetry"; items[scrollPuppetId]=0;
  /*********end id table*********/
/***********end inventory*********/

/***********troops************/
var troops = new Array(2);

function updateTroopsDisplay() {
  // Select all elements with class 'troopsDiv'
  const troopsDivs = document.querySelectorAll('.troopsDiv');

  // Loop through each 'troopsDiv' element
  troopsDivs.forEach(function (troopsDisplay) {
    troopsDisplay.innerHTML = "Troops :";
    troops.forEach(function (el, index) {
      if (troops[index] != 0)
        troopsDisplay.innerHTML += "<br>" + troopsNames[index] + " : " + troops[index];
    });
  });
}
function emptyTroopsSlot(element, index, array){
  troops[index]=0;
}
  /***********ID table***********/
var troopsNames = new Array(100);
const slimeId = 0; troopsNames[0]="Slime"; troops[slimeId]=0;
const droneId = 1; troopsNames[1]= "Drone"; troops[droneId]=0;
const maskedId = 2; troopsNames[2]= "MaskedSlave"; troops[maskedId]=0;
const mindlessSlaveId = 3; troopsNames[3]= "mindlessSlave" ;troops[mindlessSlaveId]=0;
  /*********end id table*********/
/***********end troops*********/

/***********defenses************/
var defenses = new Array(100);

function updateDefensesDisplay() {
  // Select all elements with class 'dungeonDiv'
  const dungeonDivs = document.querySelectorAll('.dungeonDiv');

  // Loop through each 'dungeonDiv' element
  dungeonDivs.forEach(function (defensesDisplay) {
    defensesDisplay.innerHTML = "Dungeon :";
    defenses.forEach(function (el, index) {
      if (defenses[index] != 0)
        defensesDisplay.innerHTML += "<br>" + defensesNames[index] + " : " + defenses[index];
    });
  });
}
function emptyDefensesSlot(element, index, array){
  defenses[index]=0;
}
  /***********ID table***********/
var defensesNames = new Array(100);
const slimeTrapId = 0; defensesNames[0]="SlimeTrap"; defenses[slimeTrapId]=0;
const cellId = 1; defensesNames[1]= "cell"; defenses[cellId]=0;
const prisonerId = 2; defensesNames[2]= "prisoners"; defenses[prisonerId]=0;
const engravingId = 3; defensesNames[3]= "engraving"; defenses[engravingId]=0;
  /*********end id table*********/
/***********end defenses*********/


/******end playeri info*********/
var storyStep = 10;
var chapter = 0;
if(localStorage.getItem("chapter")!= null)
  chapter= parseInt(localStorage.getItem("chapter"));
var actionName = "";
/**special effect*************/
  /**images*********/
var img = document.getElementById("img1"); img.src="assets/places/circle.png";
var effectForestImage = function(){img.src="assets/places/forest.png"; img.classList.add("fade-in");}
var effectCircleImage = function(){img.src="assets/places/circle.png";img.classList.add("fade-in");}
var effectCoreImage = function(){img.src="assets/places/core.png";img.classList.add("fade-in");}
var effectSeleneForestImage = function(){img.src="assets/characters/selene/seleneForest.png";img.classList.add("fade-in");}
var effectSeleneCryptImage = function(){img.src="assets/characters/selene/seleneCrypt.png";img.classList.add("fade-in");}
var effectSeleneMasked0Image = function(){img.src="assets/characters/selene/seleneMasked0.png";img.classList.add("fade-in");}
var effectSeleneMaskedImage = function(){img.src="assets/characters/selene/seleneMasked.png";img.classList.add("fade-in");}
var effect3mask1Image = function(){img.src="assets/minions/mask/3mask1.png";img.classList.add("fade-in");}
var effect3mask2Image = function(){img.src="assets/minions/mask/3mask2.png";img.classList.add("fade-in");}
var effect3mask3Image = function(){img.src="assets/minions/mask/3mask3.png";img.classList.add("fade-in");}
var effect3mask4Image = function(){img.src="assets/minions/mask/3mask4.png";img.classList.add("fade-in");}

var effectSlimeScene1Image1 = function(){img.src="assets/minions/slime/scene1/01Final.png";img.classList.add("fade-in");}
var effectSlimeScene1Image2 = function(){img.src="assets/minions/slime/scene1/02Smoked.png";img.classList.add("fade-in");}
var effectSlimeScene1Image3 = function(){img.src="assets/minions/slime/scene1/03ContaminationBegins.png";img.classList.add("fade-in");}
var effectSlimeScene1Image4 = function(){img.src="assets/minions/slime/scene1/04CorruptedPussy.png";img.classList.add("fade-in");}
var effectSlimeScene1Image5 = function(){img.src="assets/minions/slime/scene1/05AlmostComplete.png";img.classList.add("fade-in");}
var effectSlimeScene1Image6 = function(){img.src="assets/minions/slime/scene1/06Final.png";img.classList.add("fade-in");}

var effectDrainWillScene1Image1 = function(){img.src="assets/minions/slaves/mindless/scene1/01.png";img.classList.add("fade-in");}
var effectDrainWillScene1Image2 = function(){img.src="assets/minions/slaves/mindless/scene1/02.png";img.classList.add("fade-in");}

var effectNoImage = function(){img.classList.remove("fade-in");}

//******img summon***********
var imgSummon = document.getElementById("imgSummon");
imgSummon.src="assets/places/dungeon/summoningRoom.png";
imgSummon.classList.add("fade-in");

//*****Imge defenses****************

var imgDungeon = document.getElementById("imgDungeon");
imgDungeon.src="assets/places/dungeon/workshop.png";
imgDungeon.classList.add("fade-in");

var effectNoImageDefenses= function(){imgDungeon.classList.remove("fade-in");}
var effectImageDefenses = function(srcImg){imgDungeon.src=srcImg;imgDungeon.classList.add("fade-in");}

  /**end image********/

//******* img upgrade*****/
var imgUpgrade = document.getElementById("imgUpgrade");
imgUpgrade.src="";
imgUpgrade.classList.add("fade-in");

//** end img upgrade****/

//** stats changes *************/

//**  end stats changes*********/
var effectDeathBySelene = function(){
  chapter = 2;
  gameOver();
}
var effectSetChapter2= function(){
  chapter = 2;
}

  /*******hover button*****/
  /****Dungeon*****/
  const convertDroneButton = document.getElementById('convertDroneButton');
  convertDroneButton.addEventListener('mouseenter', () => {
      imgDungeon.src = "assets/minions/slime/drones/01.png";
  });
  convertDroneButton.addEventListener('mouseleave', () => {
      imgDungeon.src = "assets/places/dungeon/workshop.png";
  });

  const drainWillButton = document.getElementById('drainWillButton');
  drainWillButton.addEventListener('mouseenter', () => {
      imgDungeon.src = "assets/minions/slaves/mindless/02.png";
  });
  drainWillButton.addEventListener('mouseleave', () => {
      imgDungeon.src = "assets/places/dungeon/workshop.png";
  });

  const summonSlimeButton = document.getElementById('summonSlimeButton');
  summonSlimeButton.addEventListener('mouseenter', () => {
      imgSummon.src = "assets/minions/slime/01.png";
  });
  summonSlimeButton.addEventListener('mouseleave', () => {
      imgSummon.src = "assets/places/dungeon/summoningRoom.png";
  });

  /*****Upgrades*****/////

  const upgradeTotalAssimilationButton = document.getElementById('upgradeTotalAssimilationButton');
  upgradeTotalAssimilationButton.addEventListener('mouseenter', () => {
      imgUpgrade.src = "assets/minions/slime/drones/b03.png";
  });
  upgradeTotalAssimilationButton.addEventListener('mouseleave', () => {
      imgUpgrade.src = "";
  });

  const upgradeDrainWillButton = document.getElementById('upgradeDrainWillButton');
  upgradeDrainWillButton.addEventListener('mouseenter', () => {
      imgUpgrade.src = "assets/minions/slaves/mindless/02.png";
  });
  upgradeDrainWillButton.addEventListener('mouseleave', () => {
      imgUpgrade.src = "";
  });

  /*******Fin hover button**********/



/**fin special effect**********/

/*************costs and maxValue and upgrades*****************/
var slimeManaCost,slimeManaTime,slimeTrapTime,cellTime,makeDroneTime,drainWillManaCost,drainWillTime,maxCell,doubleTimeMax, manaMaxCost;
var resetCost = function(){
  slimeManaCost = 20; slimeManaTime = 100; 
  slimeTrapTime = 100;
  cellTime = 200;
  makeDroneTime = 300;
  drainWillManaCost = 20;
  drainWillTime = 300;
  huntLoneHumanTime = 200;
  engraveWallTime = 250;
  maxCell = 5;
  doubleTimeMax = 120;
  /****upgrades*****/
  manaMaxCost=20;

}
resetCost();
const upgrades = new Map();

upgrades.set("manaMax", 0);
upgrades.set("wallEngraving", 0);
upgrades.set("totalAssimilation", 0);
upgrades.set("drainWill", 0);

function resetUpgrades() {
  for (const [key, value] of upgrades.entries()) {
    if (typeof value === "number") {
      upgrades.set(key, 0);
    }
  } 
  document.getElementById("engraveWallButton").style.visibility = "hidden";
  document.getElementById("drainWillButton").style.visibility = "hidden";
  manaMax = 30;

  document.getElementById("upgradeWallEngravingButton").style.visibility = "visible";
  document.getElementById("upgradeTotalAssimilationButton").style.visibility = "visible";
  document.getElementById("upgradeDrainWillButton").style.visibility = "visible";

}
  //************Upgrade button effect*********
  document.getElementById("upgradeManaMaxButton").onclick =function() {
    if(mana >= manaMaxCost)
    {
      mana -= manaMaxCost;
      manaMaxCost *= 1.5;
      upgrades.set("manaMax", upgrades.get("manaMax")+1);     
      updateManaMax();  
    }
  };
  document.getElementById("upgradeWallEngravingButton").onclick =function() {
    if(mana >= 40)
    {
      mana-=40;
      upgrades.set("wallEngraving", 1); 
      document.getElementById("engraveWallButton").style.visibility = "visible";     
      document.getElementById("upgradeWallEngravingButton").style.visibility = "hidden";
    }
  };

  function updateManaMax() {
  manaMax = 30+ upgrades.get("manaMax")*10;
  manaMax *= (1 + defenses[engravingId] * 0.05);
}


  document.getElementById("upgradeTotalAssimilationButton").onclick =function() {
    if(mana >= 50)
    {
      mana -= 50;
      upgrades.set("totalAssimilation",1);    
      document.getElementById("upgradeTotalAssimilationButton").style.visibility = "hidden";   
    }
  };

  document.getElementById("upgradeDrainWillButton").onclick =function() {
    if(mana >= 70)
    {
      mana -= 70;
      upgrades.set("drainWill",1); 
      document.getElementById("upgradeDrainWillButton").style.visibility = "hidden";  
      document.getElementById("drainWillButton").style.visibility = "visible";
    }
  };
  //************fin upgrade button effect
/*************fin costs maxValue and upgrades*********************/

/****************Skill and army's contrib***********/
function getAdaptationSkillArmy(){
  return 1 + troops[mindlessSlaveId]*0.05;
};
function getAdaptationSkillTotal(){
  return skills.get("adaptationSkillLevel") * getAdaptationSkillArmy();
};
function getMagicSkillArmy(){
  return 1;
};
function getMagicSkillTotal(){
  return skills.get("magicSkillLevel");
};
function getConstructionSkillArmy(){
  let res = 1 + troops[droneId] * 0.2 + troops[mindlessSlaveId]*0.05;
  return res;
};
function getConstructionSkillTotal(){
  let res = skills.get("constructionSkillLevel") * getConstructionSkillArmy();
  return res;
};
function getFightingSkillArmy(){
  let res = 1 + troops[maskedId] * 0.2;
  res += troops[droneId] * 0.05;
  return res;
};
function getFightingSkillTotal(){
  let res = skills.get("fightingSkillLevel") * getFightingSkillArmy();
  return res;
};

/************fin skills**************************/


/*********repeatable actions*********/
var repeatActionMeditate = {desc:"Meditate", cost:50, skill:"magicSkillLevel", requirement:function(){return (mana<manaMax);},  specialEffect:function(){mana++;}};
var repeatActionSummonSlime = {desc:"Slime", cost:slimeManaTime, skill:"magicSkillLevel", requirement:function(){return (mana>=slimeManaCost);},  specialEffect:function(){mana -= slimeManaCost; slimeManaCost*=1.1;slimeManaTime*=1.1; troops[slimeId]++; updateTroopsDisplay(); } };

var repeatActionCreateSlimeTrap = {desc:"SlimeTrap", cost:slimeTrapTime, skill:"constructionSkillLevel", requirement:function(){if(troops[slimeId]<=defenses[slimeTrapId]){let narrator = document.querySelector('.narrator');narrator.innerHTML += "<br/>You already have enough trap ("+defenses[slimeTrapId]+") for all your slimes ("+troops[slimeId]+") <br/>";}return (troops[slimeId]>defenses[slimeTrapId]);},  specialEffect:function(){defenses[slimeTrapId]++;slimeTrapTime*=1.1;repeatActionCreateSlimeTrap.cost = slimeTrapTime; updateDefensesDisplay();} };
var repeatActionCreateCell = {desc:"Cell", cost:cellTime, skill:"constructionSkillLevel",requirement:function(){if(maxCell<=defenses[cellId]){let narrator = document.querySelector('.narrator');narrator.innerHTML += "<br/>Maximum amount of cells reached (5)<br/>";};return (maxCell>defenses[cellId]);},  specialEffect:function(){defenses[cellId]++;cellTime*=1.1;repeatActionCreateCell.cost = cellTime; updateDefensesDisplay();} };
var repeatActionConvertDrone = {desc:"Drone", cost:makeDroneTime, skill:"adaptationSkillLevel",  requirement:function(){return (defenses[prisonerId]>=1 && troops[slimeId]>=1);}, specialEffect:function(){defenses[prisonerId]--;troops[slimeId]--;troops[droneId]++;makeDroneTime*=1.1;repeatActionConvertDrone.cost = makeDroneTime; updateDefensesDisplay();updateTroopsDisplay();effectNoImageDefenses(); let narrator = document.querySelector('.narrator'); narrator.innerHTML += "<br/>-----------------------------------<br/>" + "A prisoner has been turned into a drone and is ready to serve."; setTimeout(effectImageDefenses.bind(null,"assets/minions/slime/drones/"+getRandomDrone()),3000); setTimeout(effectNoImageDefenses.bind(null),8000); setTimeout(effectImageDefenses.bind(null,"assets/places/dungeon/workshop.png"),11000);} };
var repeatActionDrainWill = {desc:"Drain will", cost:makeDroneTime, skill:"magicSkillLevel",  requirement:function(){return (defenses[prisonerId]>=1 && drainWillManaCost<=mana);}, specialEffect:function(){defenses[prisonerId]--;troops[mindlessSlaveId]++;drainWillTime*=1.1;repeatActionDrainWill.cost = drainWillTime; updateDefensesDisplay();updateTroopsDisplay();effectNoImageDefenses(); let narrator = document.querySelector('.narrator'); narrator.innerHTML += "<br/>-----------------------------------<br/>" + "A prisoner has been turned into a mindless slave and is ready to serve."; setTimeout(effectImageDefenses.bind(null,"assets/minions/slaves/mindless/"+getRandomMindless()),3000); setTimeout(effectNoImageDefenses.bind(null),8000); setTimeout(effectImageDefenses.bind(null,"assets/places/dungeon/workshop.png"),11000);} };
var repeatActionEngraveWall = {desc:"Engrave wall", cost:engraveWallTime, skill:"constructionSkillLevel",  specialEffect:function(){defenses[engravingId]++;engraveWallTime*=1.1;repeatActionEngraveWall.cost = engraveWallTime; updateDefensesDisplay(); updateManaMax();} };

var repeatActionHuntLoneHuman = {desc:"HuntLoneHuman, req: empty cell", cost:huntLoneHumanTime, skill:"adaptationSkillLevel", requirement:function(){return defenses[cellId]>defenses[prisonerId];},  specialEffect:function(){defenses[prisonerId]++;huntLoneHumanTime*=1.1;repeatActionHuntLoneHuman.cost = huntLoneHumanTime; updateDefensesDisplay(); notoriety+=10;} };


/***** fin specials actions******/

/********Clock and doubleTime********/
var doubleTime = 0;
let focusLostTime = null;

// Function to calculate the elapsed seconds between two timestamps
function calculateElapsedSeconds(startTime, endTime) {
    if (startTime && endTime) {
        return (endTime - startTime) / 1000; // Convert milliseconds to seconds
    }
    return 0;
}

// Event listener for when the window loses focus
window.addEventListener('blur', () => {
    focusLostTime = Date.now();
});

// Event listener for when the window gains focus
window.addEventListener('focus', () => {
    const focusGainedTime = Date.now();

    const elapsedSeconds = calculateElapsedSeconds(focusLostTime, focusGainedTime);

    // Add the elapsed seconds to doubleTime, but limit it to doubleTimeMax
    doubleTime = Math.min(doubleTime + elapsedSeconds, doubleTimeMax);

    // Reset the focusLostTime
    focusLostTime = null;
});



/********end clock and doubleTime */

function gameOver(){
  document.getElementById("gameOverDiv").classList.add("fade-in");
  isGameOver = true;
  setTimeout(function(){
    isGameOver = false;
    document.getElementById("gameOverDiv").classList.remove("fade-in");
    let narrator = document.querySelector('.narrator');
    narrator.innerHTML = "";
    softReset();
    setTimeout( notorietyBarFunction, 1000 );
    narrator.innerHTML += "<br/>-----------------------------------<br/>" + story[storyStep];
    updateScroll();
    updateStoryStep();
  }, 3000);
}

function softReset() {
  items.forEach(emptyInventorySlot);
  troops.forEach(emptyTroopsSlot);
  defenses.forEach(emptyDefensesSlot);
  updateInventoryDisplay();
  updateTroopsDisplay();
  updateDefensesDisplay();
  effectNoImage();
  notoriety = 0; notorietyMax = 100;
  notorietyLabel = $( ".progress-label" );
  mana=0; manaMax=30;
  nextWave=0;
  document.getElementById('buttonRepeat1').hidden = true;
  resetCost();
  resetUpgrades();
//*************TABS reset**********/
  if(!debug){
    document.getElementById("tabSumoning").style.display = "none";
    document.getElementById("tabDungeon").style.display = "none";
    document.getElementById("tabRaid").style.display = "none";
    document.getElementById("tabUpgrades").style.display = "none"; 
  }

tabInfos.forEach(tabInfo => {
      tabInfo.classList.remove('active')
    })
target = document.getElementById("tab_1");
    target.classList.add('active');
//**************** SAVES*************/
localStorage.setItem("adaptationSkillLevel", skills.get("adaptationSkillLevel"));
localStorage.setItem("magicSkillLevel", skills.get("magicSkillLevel"));
localStorage.setItem("constructionSkillLevel", skills.get("constructionSkillLevel"));
localStorage.setItem("fightingSkillLevel", skills.get("fightingSkillLevel"));
localStorage.setItem("chapter", chapter);
let narrator = document.querySelector('.narrator');
narrator.innerHTML+="</br>--------------------------------------------------------------</br> game saved";


//****************************

    story[9] = "I'm cold... What happened? I don't get it. I feel like I'm forgetting something very important.";
    action[9] = {desc:"Here we go again"} //action[9].desc = "Here we go again";
    story[10] = "All...Fuzzy...Hard to...Think...<br/>I feel a presence...here...<br/>A boy...A girl...Blood...";
    action[10] = {desc:"Check the boy", specialEffect:function(){story[12] = "I don't feel right, I'm covered in blood and weak. I'm in what seems to be the wreckage of a carriage. I see a girl beside me.";title = "master"; pronoun="he"; }};
    actionB[10] = {desc:"Check the girl", specialEffect:function(){story[12] = "I don't feel right, I'm covered in blood and weak. I'm in what seems to be the wreckage of a carriage. I see a boy beside me.";title = "mistress"; pronoun="she"; }};
    story[11] = "This boy is...Me? I can't remember anything.";  
    storyB[11] = "This girl is...Me? I can't remember anything.";
    action[11] = {desc:"Wake up"};
    story[12] = "I don't feel right, I'm covered in blood and weak. I'm in what seems to be the wreckage of a carriage. I see a boy beside me.";
    action[12] = {desc:"Are you alright?"};
    story[13] = "Dead, probably the unfortunate owner of all that blood.";
    action[13] = {desc:"Get up", specialEffect:effectForestImage};
    story[14] = "I manage to get up, I can hear a river not far away.";
    action[14] = {desc:"Wash yourself", specialEffect:effectNoImage};
    story[15] = "I wash myself and return to the carriage, where I find a change of clothes. If I want to find someone, I'll have to follow the road. <br/>I have this unpleasant feeling that my time is running out.";
    action[15] = {desc:"Follow the road", specialEffect:effectSeleneForestImage};
    story[16] = "Eventually I come across someone, she calls out to me: \"Hello, my name is Selene, I'd like to ask you a couple of questions. Are you all right though? You look like you're in pretty bad shape.\"";
    action[16]= {desc:"Explain the situation", specialEffect:function(){notoriety+=40;effectNoImage();}};
    story[17] = "I tell her what happened, including the fact that I've lost my memory, and she stares at me suspiciously. I have a bad feeling, as if I've just made a terrible mistake.</br>She insists I take her to the cart. After inspection, she asks me to follow her into the forest, she seems to be following a trail...";
    action[17]= {desc:"Follow her", specialEffect:effectSeleneCryptImage};
    story[18] = "She stops in front of a rock and starts to run her hand over it: \"Hmm, there's something here.\" A blinding light appears in her hand, Although her spell seems harmless, I shiver when I see her in action.</br>The rock disappears, revealing an entrance. We descend cautiously, arriving in what appears to be an ancient crypt. The place is dark and gloomy, but somehow soothing.</br>As Selene moves forward, I see an entrance to the side.";
    action[18] = {desc:"Follow Selene", specialEffect:function(){effectNoImage(); setTimeout(effectCircleImage,3000);}};
    actionB[18] = {desc:"Check the room on the side.", specialEffect:function(){effectNoImage(); setTimeout(effectCircleImage,3000);}};
    story[19] = "I decide to follow her into the next room.</br> She's in a room that was apparently used to summon demons.";
    storyB[19] = "There are some rusty old weapons in this room, as well as some creepy masks and a parchment. I try to decipher it, but it's no use, so I decide to go back to Selene.</br>She's in a room that was apparently used to summon demons.";
    action[19] = {desc:"Enter the room", specialEffect:function(){effectNoImage(); setTimeout(effectCoreImage,3000);}};
    story[20] = "Selene immediately begins to explore the room, but my attention wanders elsewhere. My body knows the way, I'm sure of it now, I've been here before. After wandering down a few corridors, I reach a dead end.</br> As if to greet me, the wall opens, revealing a room filled with magical energy. At its centre stands an imposing crystal, floating with a slight spinn.";
    action[20] = {desc:"Touch the crystal"};
    story[21] = "Fragments of memory come back to me, I've relived that day over and over again for some reason.</br>This crystal is the heart of the dungeon, where mana is stored to perform powerful rituals.</br> Only one seem to still be active. This one seems to be an emergency measure, to send me back to the past in case of death. However, it's unstable and unlikely to work, but I can try to strengthen it.";
    action[21] = {desc:"strengthen the spell, cost: 5 Mana", requirement:function(){return (mana>=5);}, specialEffect:function(){mana-=15; chapter=2; nextWave = 1;notoriety+=5;} };
    actionRepeat[21] = repeatActionMeditate;
    story[22] = "<p style=\"color:3377DD;\">-15 Mana</p></br>My vision blurs for a moment and my legs give out on me. I must have been weaker than I thought, I've managed to stabilize the spell, but it seems weak, I'm not sure it will work when the time comes. I'm too tired to move, I'll have to recover.";
    actionRepeat[22] = repeatActionMeditate;
    action[22]= {desc:"Rest, require at least 0 mana", requirement:function(){return (mana>=0);}};
    story[23] = "I'm feeling better, I'd better get back to Selene.";
    action[23]= {desc:"Join Selene", specialEffect:effectSeleneCryptImage};
    story[24] = "Selene is still searching the room, and as soon as she sees me she calls out to me: \"Could you take a look at this wall, please? Does anything look strange?\" I try to get closer to the wall to study it more closely.";
    action[24]= {desc:"Investigate", cost:150, skill:"adaptationSkillLevel", specialEffect:function(){notoriety+=100; storyStep=1000;}};
    story[25]= "...";
    story[1000] = "A pain suddenly shoots through my chest, it was no less than Selene who stabbed me, I look at her as I bleed to death, she seems to be talking to someone else:</br> \"I confirm the demon's elimination.... Are you sure it was an overlord? He was... Weak.\" I try to protest, but only blood comes out of my mouth. My vision gradually darkens...";
    action[1000] = {desc:"Death?", specialEffect:effectDeathBySelene};
    story[1001] = "I can feel the heart of the dungeon activating.";
    

    if(chapter<=1){
     storyStep = 9;
     story[9] = "I'm cold... What's happened? I don't get it. I feel like I'm forgetting something very important.";
     action[9] = {desc:"Here we go again"};
   }
    if(chapter ==0){//if it's the first initialization of the game
      storyStep = 10;
      chapter = 1;
    }

    if(chapter ==2){//You've somewhat stabilized the spell
      storyStep = 8;
      story[8] = "My time is up, but I'm not done yet, I should be able to start over. Time stops, then starts to reverse, but my body is disintegrating and it's getting harder and harder to think, looks like my spell wasn't complete after all. </br> Everything turns to darkness...";
      action[8] = {desc:"I disappear"}
      story[16] = "Eventually I come across someone, she calls out to me: \"Hello, my name is Selene, I'd like to ask you a couple of questions. Are you all right though? You look like you're in pretty bad shape.\"<br/> <p style=\"color:880000;\">\"She has to pay...\"</p> I don't know where this thought came from, as far as I know this is the first time I've met her and yet, I have a really bad feeling about this woman.";
      actionB[16]= {desc:"Lie to her", specialEffect:function(){askPlayerName() ;effectNoImage();}};
      story[18] = "She stops in front of a rock and starts to run her hand over it: \"Hmm, there's something here.\" A blinding light appears in her hand, Although her spell seems harmless, I shiver when I see her in action.<br/>The rock disappears, revealing an entrance. We descend cautiously, arriving in what appears to be an ancient crypt. The place is lovely, I feel at home here.</br> As Selene moves forward, I see an entrance to the side, I should really check what's here";
      action[18] = void 0; // = undefined
      actionB[18] = {desc:"Check the room on the side.", specialEffect:function(){effectNoImage();items[scrollPuppetId] = 1; items[maskId] = 3; updateInventoryDisplay(); setTimeout(effectCircleImage,3000);}};
      storyB[19] = "There are some rusty old weapons in this room, as well as some creepy masks and a parchment.</br> I don't know why, but I recognise these objects.</br>The masks are cursed: the wearer's soul merges with the souls of the previous owners, transforming their body and personality in unpredictable ways.</br>The parchment is a single-use Puppetry spell, allowing the caster to control the target. I decide to take them with me.</br>I decide to go back to Selene. She's in a room that was apparently used to summon demons.";
      story[21] = "Fragments of memory come back to me, I've relived that day over and over again until... Selene! That paladin will soon realise who I am and try to kill me again. <span style=\"color: 880000\">The time has come for vengeance</span>.</br>  This crystal is the heart of the dungeon, where mana is stored to perform powerful rituals. However, only one seem to still be active. This one seems to be an emergency measure, to send me back to the past in case of death.</br>It's unstable and unlikely to work, but I can try to strengthen it.</br>I remember last time, I almost fainted from lack of mana, I won't do the same mistake again.";
      action[21] = {desc:"strengthen the spell, cost: 15 Mana", requirement:function(){return (mana>=15);}, specialEffect:function(){mana-=15;nextWave = 1;}};
      story[22] = "I've managed to stabilize the spell, I know it won't be enough to ensure I keep all my memories, but that's all I can do for now. Now I have to take care of the paladin before she realize what I am. </br>I could try to put a mask on her, this will have an unpredictable result, but at least she won't be dangerous anymore.</br> I could also use my puppetry spell on her, having her under my power could prove useful, but I only have one scroll, maybe I should keep it for now.";
      action[22]= {desc:"Prepare a mask", specialEffect:effectNoImage};
      actionB[22] = {desc:"Prepare puppetry spell, cost: 10 Mana", requirement:function(){return (mana>=10);}, specialEffect:function(){mana-=10;effectNoImage();action[23] = undefined;actionB[23] = {desc:"Join Selene", specialEffect:function(){effectSeleneCryptImage(); storyStep = 38;notoriety=0; notorietyMax = 40; nextWave =3;}};}};
      story[23] = "I've devised a plan to put a mask on her, it's time to join Selene. ";
      storyB[23] = "My spell is ready and I have enough mana to cast it, it will take time for my spell to take effect, and there's nothing between her and me to stop her cutting me up in the meantime, however, I have an idea to try and divert her attention.</br> It's time to join Selene.";
      story[24] = "She is still searching the room, and as soon as she sees me she calls out to me: \"Could you take a look at this wall, please? Does anything look strange?\"</br>I interrupt her and give her one of my masks: \"I found it in this room.\" Given her reaction, it's obvious that she knows this object is dangerous, she starts to head towards the room I've indicated, without taking her eyes off it.";
      //storyB[24] = "She's still in the room where I left her.";
      action[24]= {desc:"Use a mask", specialEffect:function(){notoriety=0; notorietyMax = 20; nextWave =2;items[maskId]--; updateInventoryDisplay(); effectNoImage(); setTimeout(effectSeleneMasked0Image,3000); }};
      story[25] = "When she walks past me I immediately pull out another mask and place it over her face. She reacts instantly by jumping away from me, but it's too late.</br>She tries to remove it but it doesn't budge, continuing to merge with its host. After a short and futile resistance, her arm falls back down her body and she starts laughing hysterically."
      action[25]= {desc:"She is doomed", specialEffect:effectNoImage};
      story[26] = "The mask's influence spreads through her, changing her body, even corrupting her armor.";
      action[26]= {desc:"Welcome your new servant", specialEffect:effectSeleneMaskedImage};
      story[27] = "\"Welcome, I hope you like the new you.\"</br> Her laughter gives way to a sigh of happiness: \"Thank you "+title+"... Who do you want me to <span style=\"color: AA0000\">kill</span>?\"</br> \"No one, for the moment you just have to make sure that no one enters my domain.\"</br> \"So if anyone tries to get in, I have to <span style=\"color: AA0000\">kill</span> them, don't I? Oh, I've got to tell you, the paladins will probably send someone after me quickly if I don't report back, and I doubt I'll be able to convince them nothing happened even if I tried.</br> But don't worry, when they arrive I'll <span style=\"color: AA0000\">kill</span> them!\"</br> Oh dear, another freak that's why I hate those masks you never know what to expect. \"NO! Listen, you're not killing anyone unless I ask you to do it, for now we have to prepare ourselves.\" </br>I say that but I don't think I'll be able to setup a trap with so little time, I could gather some mana for later but I can't remember any offensive spell.";
      actionRepeat[27] = repeatActionMeditate;
      story[28] = "As expected, Selene's former allies have come looking for her. There are 3 of them and they advance cautiously, when they see me they approach quickly : \"WHERE IS SHE?!\"</br>\"I think there's been a misunderstanding, who are you talking about?\"</br>\"Don't make fun of us, we know she's here, tell us where she is or you'll die!\"</br>\"Does that mean you'll let me live if I cooperate?\"</br>\"Just tell us where she is!\"";
      action[28]={desc:"\"Right behind you!\"", specialEffect:effectNoImage};
      story[29] = "Selene comes out of hiding to pounce on one of her former allies, I take advantage of the confusion to pull out a mask and put it on my nearest opponent, who then rolls to the ground in panic as she try to remove it.</br> The latter charges at me with her sword, I run while dodging her attacks, but I'm not going to be able to hold out for long.</br>\"Selene I need your help, NOW!\"</br>\"Of course "+title+", I just need to <span style=\"color: AA0000\">kill</span> her first! AHAHA <span style=\"color: AA0000\">MURDER!</span>\" </br>\"SELENE!\"</br>My attacker charges me again, I'm about to dodge but my body doesn't react any more, I realise that her sword is deep in my abdomen. Fuck, I shouldn't have relied on those masks. A sharp pain runs through me as the world around me fades away.";
      action[29]={desc:"Darkness", specialEffect:effectDeathBySelene};
      story[30] = "I can feel the heart of the dungeon activating.";
      //story[38] = "She's still in the room where I left her.. ";
      storyB[39] = "She's still in the room where I left her.";
      action[39]={desc:"Next"};
      story[40] = "When I see her I pull out one of my masks to show her.\"Hey Selene, look what I found in the other room!\"</br>I start staring at the mask: \"Creepy, isn't it? Well, creepy, but quite pretty... I wonder what I'd look like wearing it...\" Slowly, I pull the mask closer to my face.</br>\"WATCH OUT!\" Suddenly she runs towards me and knocks the mask away.\"Don't touch it, it's cursed!\"</br>Oh I know that of course, I thank my \"saviour\" who then walks over to the fallen mask. As she bends down to pick it up, I start to channel my spell.";
      action[40]={desc:"Cast puppetry spell", specialEffect:function(){items[scrollPuppetId]--; updateInventoryDisplay();} };
      story[41] = "The second she puts her finger on it, I cast my spell. She realises immediately, but blames the mask for her affliction.</br> I push her to put it on, she resists effortlessly, but with each passing second my hold on her intensifies.</br> Fearing she's losing control, she throws it away, stupor overcoming her as she realises she's still under.";
      action[41]={desc:"Next"};
      story[42] = "\"Why?\"</br> \"It's strange isn't it? It's as if your problem came from somewhere else...\"</br>\"YOU!\" She draws her sword, and prepares to strike in my direction, but it's too late.</br>\"drop your weapon.\" Her hand opens just as she's about to hit me, dropping her weapon, she reacts by trying to punch me in the face. \"Stop.\" I feel the breath of her blow on my face as her fist stops right in front of my nose.</br>\"Hoho that was close. Be careful or you might hurt someone\" She remains completely still. \"This position can't be comfortable, just let me...\" Gently, I take her arms and place them along her body as I might do with a doll.";
      action[42]={desc:"Next"};
      story[43] = "\"Now let's talk about your behaviour... To begin with, you are not allowed to harm me in any way, in fact you'll do everything in your power to protect me. Furthermore, you will carry out my orders without hesitation. That should be enough for now, you can move now.\"</br>\"You're not going to get away with this, my sisters will come looking for me and they'll make you pay!\"</br>\"Sshh, don't worry about that, I have no doubt that, with your help, it'll be fine. Why don't you start by fetching that little beauty you outrageously threw on the floor?\"</br>She complied without putting up the slightest resistance, picking up the mask and handing it to me. \"Nah keep it, and take mine while you're at it, you're going to need them.\"</br>I finish giving my new puppet her instructions, now all I have to do is wait for her allies to arrive.";
      action[43]={desc:"Wait", specialEffect:function(){notoriety+=100;effectNoImage();}};
      actionRepeat[43] = repeatActionMeditate;
      story[44] ="I wait for them to arrive."
      story[45] ="I'm waiting in the heart of the dungeon, from where I can see absolutely everything that's going on in my lair. It doesn't take long for them to arrive, three of them. When they find Selene, they rush to her side. </br>\"Why didn't you answer, we were worried sick! The oracle confirmed that a demon was near you.\"</br>\"It's gone down this corridor\" As they head off in the direction indicated, Selene behind the group takes the opportunity to put a mask on one of her allies, who starts screaming.</br> The others see her struggling and help her remove it, Selene takes the opportunity to try and get them too. She succeeds in dressing the head of another of her sisters, but the latter reacts in time.</br>\"WHAT ARE YOU DOING SELENE?! GET AWAY FROM THEM!\" She stands between the traitor and her victims, ready to fight. Things seem to be going well, I think it's time to join them.";
      action[45]={desc:"Join them", specialEffect:effect3mask1Image};
      story[46] ="When I arrive, Selene is still fighting the only sane person left.</br>\"Well done Selene, one more to go and we'll be done here.\"</br>\"You! This is your doing isn't it?\"</br>She is quickly interrupted by her two allies who grab her while laughing hysterically.</br> \"Get off me!\"</br>Selene moves closer, preparing to seal the fate of the latest intruder.</br>\"Selene, pull yourself together, you don't have to do this, PLEASE!\"</br>For a brief moment, Selene manages to resist me, letting her mask fall to the floor. I move closer to her, placing my hands on her waist: \"Poor thing, there's no point resisting now, don't listen to her, just listen to my voice, the voice of your "+title+".\"</br>I pick up the last piece of the puzzle and give it back to her so she can complete it: \"You know what you have to do... Take it... Yes, like that, and now all you have to do is put it down gently.\" Selene obeyed, her victim so terrified she can't resist. </br>\"Good girl\" It doesn't take long for the last paladin to join the others in the madness, changing her personality...";
      action[46]={desc:"Next", specialEffect:function(){effectNoImage(); setTimeout(effect3mask2Image,3000);} };
      story[47] ="...And appearance...";
      action[47]={desc:"Next", specialEffect:function(){effectNoImage(); setTimeout(effect3mask3Image,3000);} };
      story[48] ="...Its influence spreading through her body...";
      action[48]={desc:"Next", specialEffect:function(){effectNoImage(); setTimeout(effect3mask4Image,3000);} };
      story[49] ="Selene falls to her knees in deep dismay: \"I've failed... It's all over...\" </br> \"Quite the opposite, you've been stellar, and this is just the beginning.\"";
      action[49]={desc:"Next", specialEffect:function(){effectNoImage(); troops[maskedId]+=3;updateTroopsDisplay(); items[maskId]-=3;updateInventoryDisplay();} };
      story[50] = "Hehehe, Now that the paladins are under my control, there's nothing immediately threatening me.</br>However, I have spent all the resources at my disposal, and my presence in these lands will not go unnoticed forever.</br> It's not as if I'm going to put up with hiding forever anyway, soon everyone will learn to worship me and those who refuse will be... Fixed.";
      action[50]={desc:"Next", specialEffect:function(){document.getElementById("tabSumoning").style.display = "block"} };
      story[51] = "Unfortunately in my state I'm not even capable of influencing the minds of these pathetic creatures any more.</br>First of all, I have to rebuild my domain. Luckily, the summoning room is intact, which should allow me to acquire the manpower I so desperately need.</br><span class=\"tutorial\"> Summoning room unlocked! To access it, click on the corresponding tab.</br> From the summoning room, you can summon demons from the underworld for mana. You should start by summoning a slime.</span>";
      action[51]={desc:"My minion is ready, Req:1Slime", requirement:function(){return (troops[slimeId]>=1);}, specialEffect:function(){document.getElementById("tabDungeon").style.display = "block"} };
      story[52] = "Perfect! These beauties come in many shapes and colours, but they all have one thing in common: they're the perfect tool for capturing intruders who are a little too curious.</br>However, it needs a place to hide in order to surprise its prey, so I'm going to have to build a trap if I want to capture someone with it.</br><span class=\"tutorial\"> Defence tab unlocked! Here you can build traps and other defences to protect yourself from intruders.</br>Slime trap unlocked! When intruders enter your dungeon, these traps activate to capture intruders. Each trap can only capture one enemy per raid and requires a slime to do so.</br>However, the traps can be used again for each subsequent attack, as long as you have enough slimes.</span>";
      action[52]={desc:"The trap is set, Req:1SlimeTrap 1Slime",requirement:function(){return (defenses[slimeTrapId]>=1 && troops[slimeId]>=1);}};
      story[53] ="That's it, the trap is ready to close on the next intruders to arrive in my dungeon, but I should test it on defenceless victims before facing any real opponents, so now, the hunt begins!";
      action[53]={desc:"Next"};
      story[54] ="I don't have much of an army, let alone troops that can act covertly, so I decide to go off on my own in the hope of finding someone gullible enough to follow me.</br> Of course I could have asked Selene to come with me, but I don't want rumours of a paladin in the area so soon after her disappearance.";
      action[54]={desc:"Next", specialEffect:effectSlimeScene1Image1};
      story[55] ="It took a while, humans rarely travel alone, but I finally came across a woman walking on her own.</br> \"Hello, aren't you worried travelling by yourself?\"</br>\"Oh no, don't worry, no one would dare harm me, the Order of Paladins ensures the safety of us all. I've never seen you in Petipatlin, are you from the capital?\"</br>So humans can walk alone in the middle of the forest without the slightest fear... This world has become quite boring...";
      action[55]={desc:"lure her", specialEffect:effectNoImage};
      story[56] ="\"If I understand correctly, you're an alchemist? I regularly harvest the rare plants I find but I'm always afraid of making a mistake. Could you help me identify them? I live a little further away, and maybe you'll find something that interests you.\"</br>\"Yes, of course, I'm always happy to help.\"</br>She gives me a radiant smile... That's why I hate peaceful times, people who are afflicted with both kindness and naivety would usually struggle even to survive, but here she is, without a care in the world... It's time to put things back in order.</br>I guide her to my lair, she starts to get nervous as she realises the size of my domain.</br>\"It's getting late, maybe I should...\"</br> \"We're almost there, keep going.\"";
      action[56]={desc:"The trap activates", specialEffect:effectSlimeScene1Image2};
      story[57] ="She takes a few steps forward before turning around: \"I think I'd better go, it's getting late and- what on earth... My head's...\"</br>The slime hidden in the ceiling releases a toxic cloud, melting her victim's clothes. Normally she'd panic, but it's also debilitating. She has an absence that lasts a few seconds, but that's enough for her to end up completely naked.";
      action[57]={desc:"It begins", specialEffect:function(){effectNoImage(); setTimeout(effectSlimeScene1Image3,3000);} };
      story[58] ="My servant then drops onto its prey, which shakes her out of her stupor. Seeing her chest assaulted in this way, she tries to get rid of her attacker, but all she manages to do is spread the contamination to her hand.</br>\"What's happening to me?\"</br>\"This slime is spreading all over your body, taking control of it.\"</br>\"NO!\"</br>\"Rejoice, your miserable existence will finally have a meaningful purpose. I'm going to use you to rebuild my domain, you should be honored.\"</br>She begins to shake herself in an attempt to slow the spread. \"No! You have to stop this!\"</br>I grab her hand: \"Let me help you, you see this process can be a bit unsettling, but it's much more enjoyable if you start with the best part.\"";
      action[58]={desc:"Help her", specialEffect:function(){effectNoImage(); setTimeout(effectSlimeScene1Image4,3000);}};
      story[59] ="Quickly I bring her hand up to her pussy, she pushes me away immediately, but it's too late. Soon her crotch is completely covered and she lets out a scream of pleasure.</br> The slime is growing faster now, feeding off the fluids of its victims, which it stimulates with slow but regular pulses. It acts like an unholy heart, growing bigger and bigger beat after beat, corrupting its victim in the process.</br>She no longer knows how to stop it, and sinks into despair, her uncontrollable orgasms rhythmed by its sinister pulse eroding her will.</br>";
      action[59]={desc:"Next"};
      story[60] ="It would probably be over if she wasn't struggling so much : \"No NO NO NO! There's got to be a way to stop this.\" </br>I interrupt her : \"What would be the point? Have you ever felt such pleasure? Soon your whole body will be perpetually immersed in it, and when it reaches your head, all your worries will disappear, leaving only the bliss of submission.\"</br>I continue : \"So I'll make you a deal: you stop resisting immediately, and in exchange you get what you want much more quickly.\"</br>\"NO!\"</br> \"Think about it, you like this feeling, you want more pleasure, don't you? All you have to do is let yourself go.\"</br> To help her make up her mind, I start licking the nipple that hasn't yet been reached, occasionally moving up to slip a few kiss on her chest and neck.</br> Seeing no way out, it doesn't take long for my victim to admit defeat : \"AAAAH, YES!\"</br>\"Do you understand now? Resisting is a waste of time, deep down you know you're dying for it, you just have to let go. Focus on the pleasure.\"</br>\"Yess... Pleasure...\"";
      action[60]={desc:"Next", specialEffect:function(){effectNoImage(); setTimeout(effectSlimeScene1Image5,3000);} };
      story[61] ="\"Hehe good girl.\" She's done, and without the slightest resistance on her part, it doesn't take long for the corruption to spread down her arms and legs, now attacking her face.</br> She waits passively to be reborn, the only movement she lets perceive are the waves running through her body with each stimulation she receives as a reward for her docility.</br> The last cries of joy that could still be heard fade away as her symbiote infiltrates her ear.</br> They will have been the last actions she took of her own accord. This body no longer belongs to her, it's only an extension of the will of its new occupant, and therefore, of mine!";
      action[61]={desc:"Next", specialEffect:function(){effectNoImage(); setTimeout(effectSlimeScene1Image6,3000); troops[droneId]++;troops[slimeId]--; updateTroopsDisplay();document.getElementById("tabRaid").style.display = "block";} };
      story[62] ="As the fusion ends, she remains motionless for a few moments, until \"it\" awakes. Its eyes periodically appear and disappear on its new host before it begins to set it in motion.</br>\"Welcome minion, as you can see my lair is a mess. I'll give you more instructions later, but for now you can just clean it up until further notice.\"</br> For a moment, all its eyes look in my direction, recognizing me as its "+title+", then my drone silently heads for its first task.</br>Good, as long as I've got some slimes to occupy the traps, I should be able to capture those who attack me, or any prey I manage to bring in.</br><span class=\"tutorial\"> First drone captured! It will automatically help you in any task that uses \"construction\" skill, speeding up the process. </br> For now, each drone increase your construction speed by 20%, this is represented by the second number you can see after your constructionSkill</span></br><span class=\"tutorial\">Raid tab unlocked! From here, you can hunt humans, or attack/infiltrate their camp. </br> Be careful, though, as it will take longer and longer to find easy targets as the news of disappearances continues to spread. </br> What's more, each hunt will increase your notoriety, bringing the next attack that much closer.</span>";
      

      action[62]={desc:"Next", specialEffect:function(){document.getElementById("tabUpgrades").style.display = "block";effectNoImage();} };
      story[63] ="Excellent, although too slow to fight, drones will be perfect for rebuilding my dungeon.</br>However, it's going to be increasingly expensive to summon more slimes, so I'm going to need a more sustainable way to enslave more humans.</br>If I pour some mana into the dungeon core, I should be able to get my powers back. My priority should be to get a spell to enslave those who resist me.</br><span class=\"tutorial\">The upgrade tab has been unlocked, here you can spend mana to get various upgrades or unlock new things.</span>";
      action[63]={desc:"Next Req:DrainWill, 1 Prisoner", requirement:function(){return (upgrades.get("drainWill")>0 && defenses[prisonerId]>=1)} };
      story[64] ="Instilling loyalty in a subject is extremely difficult. It takes an extremely powerful emotion to ensure the target's obedience and it requires an enormous amount of power.</br>However, as with anything, human emotions are much easier to destroy than to emulate. All I have to do is suck out all their desires until there's nothing left.</br>Then they'll be ready to accept any suggestion, as long as it fills the emptiness inside them.";
      action[64]={desc:"Next", specialEffect:function(){effectNoImage(); setTimeout(effectDrainWillScene1Image1,3000);}};
      story[65] ="I'm visiting one of our prisoners, the idiot seems happy to see me.</br>\"Are you here to save me? I was attacked by masked demons and they've been holding me prisoner ever since.\"</br>I can't help smiling: \"Rescue you? You could say that, yes.\"</br>\"Thanks goodness, we've got to get out of here.\"</br>I put my hand on her chest : \"First of all, I need to make sure you're not cursed.\"</br>What are... What are you doing?\"</br>\"It seems you have been hit by a curse, let me heal you.\"</br>\"No, I was fine before... Before you... You...\"</br>\"You need to relax, let me take care of you.\"";
      action[65]={desc:"Next"};
      story[66] = "\"I need to relax... No... something's wrong. I want to go home.\"</br>\"You don't want to go home, you want to relax.\"</br>\"I want to go... Home?.. I want to... I... I don't want to go home... But I want to get out of here!\"</br>\"You don't want to leave, you don't want anything.\"</br>\"I don't want to leave... I don't want anything... No! This is wrong!\"</br>\"Don't worry, just relax and let that sweet torpor wash over you.\"</br>\"I want... My head... Please stop...\"</br>\"You don't really want me to stop, in fact you don't want anything at all.\"</br>\"That's not true... I want... I want... Things...\"</br>\"Oh, and what is it that you want so much?\"";  
      action[66]={desc:"Next", specialEffect:function(){effectNoImage(); setTimeout(effectDrainWillScene1Image2,3000); defenses[prisonerId]--; troops[mindlessSlaveId]++;}};
      story[67] = "\"I want... I want... I don't know... What do I want?\"</br>\"You are my slave, and your only desire is to serve me.\"</br>\"Oh, I see... That makes sense... I'll serve you.\"</br>\"There's nothing more important to you than obeying me, in fact, nothing else matters to you.\"</br>\"Nothing else...\"</br>\"From now on I'm your "+title+". You will carry out my orders without the slightest hesitation.\"</br>\"Yes "+title+". You order, I obey.\"</br>Perfect! I give her her instructions and watch her with amusement for a moment, before seeing her leave to assist my drones.</br> What a pleasure to finally be able to enslave them with my own hands! I can already imagine thousands of them kneeling before me!</br> The thought arouses me, maybe I should have used my new toy before she left... Speaking of toys, where's Selene?";
      action[67]={desc:"End"};

      story[68] = "End of the main story !</br> You can still continue to play, there is now a total of 6 random illustrations to be seen when converting a drone (3 basic and 3 after totalAssimilation upgrade) and 2 when using drainWill (including the one you saw in the story)</br> I hope you enjoyed the game so far, I'll post the latest updates for my games on my <a href=\"https://www.patreon.com/GratuitousLove\" target=\"_blank\">Patreon</a> (2 new releases/month).</br>You can also support me here (thank for those who do, it really helps<3). Patrons have acces to updates ealier, can vote for polls and I also sometimes post artwork sooner or with higher res.";
      //action[63]={desc:"End of content", specialEffect:effectDeathBySelene};
      //story[51] = "Thanks for playing";
      
      updateStoryStep();
    }
  };
  softReset();

  function updateScroll() {
    var element = document.getElementById("narratorText");
    element.scrollTop = element.scrollHeight;
  }


  function updateAllDisplay(){
    updateManaMax();

    updateTroopsDisplay();
    updateSkillDisplay();
    updateDefensesDisplay();
    updateInventoryDisplay();
    updateSkillDisplay();
    //updateTooltips();
    setTimeout(updateAllDisplay,1000);
  }updateAllDisplay();


  function notorietyBarFunction() {
    $( function() {
      var notorietyBar = $( "#notorietyBar " ),
      notorietyLabel = $( ".progress-label" );

      notorietyBar.progressbar({
        value: false,
        change: function() {
          notorietyLabel.text( Math.floor(notorietyBar.progressbar( "value" )) +", X2:"+Math.floor(doubleTime) );
          
        },
        complete: function() {
          notorietyLabel.text( "!!!" );
          actionName = "";
          let narrator = document.querySelector('.narrator');
          switch (true) {
          case nextWave==0:
            gameOver();
            break;
          case nextWave==1:
            storyStep = 999;
            narrator.innerHTML += "<br/>-----------------------------------<br/>" + story[storyStep+1];
            storyStep++;
            updateScroll();
            updateStoryStep();
            break;
          case nextWave==2:
            storyStep = 27;
            narrator.innerHTML += "<br/>-----------------------------------<br/>" + story[storyStep+1];
            storyStep++;
            updateScroll();
            updateStoryStep();
            notoriety=0;
            break;
          case nextWave==3:
            storyStep = 44;
            narrator.innerHTML += "<br/>-----------------------------------<br/>" + story[storyStep+1];
            storyStep++;
            updateScroll();
            updateStoryStep();
            notoriety=0;
            notorietyMax = 80;
            break;
          case (nextWave>=4):
            narrator.innerHTML += "<br/>-----------------------------------<br/>" + "You are being attacked !";
            let enemyVillagersCount = calculateFibonacci(nextWave-3);
            narrator.innerHTML +="</br> enemy army : </br>-Villager :"+enemyVillagersCount+"</br>";
            let armedTraps = Math.min(troops[slimeId],defenses[slimeTrapId]);
            let trapped=0;
            if(armedTraps>0){
              trapped = Math.min(armedTraps, enemyVillagersCount);
              narrator.innerHTML +=trapped+" ennemies have been trapped </br>";
            }
            enemyVillagersCount-= trapped;
            narrator.innerHTML +="Remaining ennemy strength : "+enemyVillagersCount+" your fighting power is : "+Math.floor(getFightingSkillTotal()*10)/10+"</br>";
            if(enemyVillagersCount >getFightingSkillTotal()){
              narrator.innerHTML +="The ennemies overwhelm you !";
              updateScroll();
              gameOver();
            }
            else{
              notoriety=0;
              if(nextWave ==4)
                narrator.innerHTML +="</br> It seems that this \"attack\" was just an over-curious villager, but their disappearance will attract the attention of more enemies, so I should prepare some defensive measures.</br>"
              notorietyMax = 50;
              let exp = nextWave/10;
              exp = exp/skills.get("fightingSkillLevel");
              let victoryMsg ="You are victorious ! </br>";
              if(trapped >0) victoryMsg+=trapped+" ennemies have been trapped and transformed into drones, consuming "+trapped+" slimes in the process </br>";
              victoryMsg+="Your fightingSkill has increased by : "+Math.round(exp*100)/100;
              narrator.innerHTML +=victoryMsg;
              skills.set("fightingSkillLevel", skills.get("fightingSkillLevel")+exp );
              troops[droneId]+= trapped;
              troops[slimeId]-= trapped;
              updateTroopsDisplay();
              updateScroll();
            }                
            break;
          }
          nextWave++;
        }
      });

      function progress() {
        if(actionName != ""){
          notoriety+=0.1;
        }
        notorietyBar.progressbar( "value", (notoriety)*100/notorietyMax );
/*
        let adaptationDiv = document.getElementById('AdaptationDiv');
        adaptationDiv.innerHTML ="AdaptationSkill : " + (Math.round(skills.get("adaptationSkillLevel") * 100) / 100)+ " * "+getAdaptationSkillArmy() + " = "+Math.round(getAdaptationSkillTotal()*100)/100;
        let meditationDiv = document.getElementById('MagicDiv');
        meditationDiv.innerHTML ="MagicSkill : " + (Math.round(skills.get("magicSkillLevel") * 100) / 100)+ " * "+getMagicSkillArmy()+ " = "+Math.round(getMagicSkillTotal()*100) / 100;
        let constructionDiv = document.getElementById('ConstructionDiv');
        constructionDiv.innerHTML ="ConstructionSkill : " + (Math.round(skills.get("constructionSkillLevel") * 100) / 100)+ " * "+getConstructionSkillArmy()+ " = "+Math.round(getConstructionSkillTotal()*100)/100;
        let fightingDiv = document.getElementById('FightingDiv');
        fightingDiv.innerHTML ="FightingSkill : " + (Math.round(skills.get("fightingSkillLevel") * 100) / 100)+ " * "+getFightingSkillArmy() + " = "+Math.round(getFightingSkillTotal()*100)/100;*/

        document.querySelectorAll('.ManaDiv').forEach(el=>{
          el.innerHTML="mana : " + Math.round(mana)+"/"+manaMax;
        });

        if ( notoriety < 100 && !isGameOver) {
          setTimeout( progress, 100 );
        }
      }

      setTimeout( progress, 0 );
    } );
  }
  $(document).ready(notorietyBarFunction());


  function updateStoryStep(){
    if(action[storyStep] == undefined){
      document.getElementById('button1').hidden = true;
    }else{
      document.getElementById('button1').hidden = false;
      document.getElementById('button1').innerHTML = action[storyStep].desc;
    }

    if(actionB[storyStep] == undefined){
      document.getElementById('button2').hidden = true;
    }else{
      document.getElementById('button2').hidden = false;
      document.getElementById('button2').innerHTML = actionB[storyStep].desc;
    }

    if(actionRepeat[storyStep] == undefined){
      document.getElementById('buttonRepeat1').hidden = true;
    }else{
      document.getElementById('buttonRepeat1').hidden = false;
      document.getElementById('buttonRepeat1').innerHTML = actionRepeat[storyStep].desc;
    }
  }

  document.getElementById("button1").onclick =function() {
    if(actionName == "button1"){return 0;}//une seule action à la fois
    if(action[storyStep].requirement!= undefined){if(!action[storyStep].requirement()){return 0;}}
    actionName = "button1";
    var actionBar = $( "#actionBar" ),
    actionLabel = $( ".action-label" );


    actionBar.progressbar({
      value: false,
      change: function() {
        //actionLabel.text( actionBar.progressbar( "value" ) + "%" );
      },
      complete: function() {
       if(action[storyStep].specialEffect != undefined){
         action[storyStep].specialEffect();
       }

       let narrator = document.querySelector('.narrator');
       narrator.innerHTML += "<br/>-----------------------------------<br/>" + story[storyStep+1];
       updateScroll();
       storyStep++;
       actionName = "";
       updateStoryStep();

     }
   });

    



    actionBar.progressbar("value", 1);

    actionLabel.text( action[storyStep].desc );

    function progress() {
      if(actionName !="button1" ){return 0;}

      var val = actionBar.progressbar( "value" ) || 100; 
      var increment;
      if(action[storyStep].cost == undefined){//si on a actionCost alors il faut aussi remplit actionSkill
       increment = 4*skills.get("adaptationSkillLevel");  
       skills.set("adaptationSkillLevel",skills.get("adaptationSkillLevel")+0.001/skills.get("adaptationSkillLevel"));
     }
     else {
       increment = (100*skills.get(action[storyStep].skill))/action[storyStep].cost;
       skills.set("adaptationSkillLevel",skills.get(action[storyStep].skill)+0.001/skills.get(action[storyStep].skill));
     }                       
     actionBar.progressbar( "value", val + increment )

     if ( val < 100-increment ) {
      if(doubleTime>0.1)
      {
        doubleTime-=0.1;
        setTimeout( progress, 50 );
      }else{
        setTimeout( progress, 100 );
      }
    }
  }

  setTimeout( progress, 0 );
};

document.getElementById("button2").onclick =function() {
  if(actionName == "button2"){return 0;}
  if(actionB[storyStep].requirement!= undefined){if(!actionB[storyStep].requirement()){return 0;}}
  actionName = "button2";
  var actionBar = $( "#actionBar" ),
  actionLabel = $( ".action-label" );


  actionBar.progressbar({
    value: false,
    change: function() {
        //actionLabel.text( actionBar.progressbar( "value" ) + "%" );
    },
    complete: function() {
      if(actionB[storyStep].specialEffect != undefined){
       actionB[storyStep].specialEffect();
     }
     let narrator = document.querySelector('.narrator');
     narrator.innerHTML += "<br/>-----------------------------------<br/>" + storyB[storyStep+1];
     updateScroll();
     storyStep++;
     actionName = "";
     updateStoryStep();
   }
 });



  actionBar.progressbar("value", 1);

  actionLabel.text( actionB[storyStep].desc );

  function progress() {
    if(actionName !="button2" ){return 0;}

    var val = actionBar.progressbar( "value" ) || 100; 
    var increment;
      if(action[storyStep] == undefined || action[storyStep].cost == undefined){//si on a actionCost alors il faut aussi remplir actionSkill
       increment = 4*skills.get("adaptationSkillLevel");  
       skills.set("adaptationSkillLevel",skills.get("adaptationSkillLevel")+0.001/skills.get("adaptationSkillLevel"));
     }
     else {
       increment = (100*skills.get(actionB[storyStep].skill))/actionB[storyStep].cost;
       skills.set("adaptationSkillLevel",skills.get(actionB[storyStep].skill)+0.001/skills.get(action[storyStep].skill));
     }                       
     actionBar.progressbar( "value", val + increment )

     if ( val < 100-increment ) {
      if(doubleTime>0.1)
      {
        doubleTime-=0.1;
        setTimeout( progress, 50 );
      }else{
        setTimeout( progress, 100 );
      }
    }
  }

  setTimeout( progress, 0 );
};

document.getElementById("buttonRepeat1").onclick =function() {
    if(actionName == "buttonRepeat1"){return 0;}//une seule action à la fois
    if(actionRepeat[storyStep].requirement != undefined)
      {if(!actionRepeat[storyStep].requirement()){return 0;}}//on s'assure que les conditions sont toujours réunies (ex meditate must stop when mana >= manaMax)
    actionName = "buttonRepeat1";
    var actionBar = $( "#actionBar" ),
    actionLabel = $( ".action-label" );

    actionBar.progressbar({
      value: false,
      change: function() {
        //actionLabel.text( actionBar.progressbar( "value" ) + "%" );
      },
      complete: function() {
       if(actionRepeat[storyStep] != undefined)
        if(actionRepeat[storyStep].specialEffect != undefined){
         actionRepeat[storyStep].specialEffect();
       }
       actionName = "";
       setTimeout( document.getElementById("buttonRepeat1").onclick(), 0 );
     }
   });



    actionBar.progressbar("value", 1);

    if(actionRepeat[storyStep] != undefined)
      actionLabel.text( actionRepeat[storyStep].desc );

    function progress() {
      if(actionName !="buttonRepeat1" ){return 0;}

      var val = actionBar.progressbar( "value" ) || 100; 
      var increment;
      if(actionRepeat[storyStep] == undefined || actionRepeat[storyStep].cost == undefined){//si on a actionCost alors il faut aussi remplit actionSkill
       increment = 4*skills.get("adaptationSkillLevel");  
       skills.set("adaptationSkillLevel",skills.get("adaptationSkillLevel")+0.001/skills.get("adaptationSkillLevel"));
     }
     else {
       increment = (100*skills.get(actionRepeat[storyStep].skill))/actionRepeat[storyStep].cost;
       skills.set(actionRepeat[storyStep].skill,skills.get(actionRepeat[storyStep].skill)+0.001/skills.get(actionRepeat[storyStep].skill));
     }                       
     actionBar.progressbar( "value", val + increment )

     if ( val < 100-increment ) {
      if(doubleTime>0.1)
      {
        doubleTime-=0.1;
        setTimeout( progress, 50 );
      }else{
        setTimeout( progress, 100 );
      }
    }
  }

  setTimeout( progress, 0 );
};


//*********************************BUTTONs!********************************************************//




// Reusable function to handle button actions
function handleButtonClick(buttonName, action, actionLabelContent, description) {
    if (actionName === buttonName) {
        return;
    }

    if (action.requirement !== undefined) {
        if (!action.requirement()) {
            return;
        }
    }

    actionName = buttonName;

    var actionBar = $("#actionBar");
    var actionLabel = $(".action-label");

    actionBar.progressbar({
        value: false,
        change: function () {
            // actionLabel.text(actionBar.progressbar("value") + "%");
        },
        complete: function () {
            action.specialEffect();
            actionName = "";
            setTimeout(() => document.getElementById(buttonName).onclick(), 0);
        },
    });

    actionBar.progressbar("value", 1);

    actionLabel.text(actionLabelContent);

    function progress() {
        if (actionName !== buttonName) {
            return;
        }

        var val = actionBar.progressbar("value") || 100;
        var increment;

        if (action === undefined || action.cost === undefined) {
            increment = 4 * skills.get("adaptationSkillLevel");
            skills.set("adaptationSkillLevel", skills.get("adaptationSkillLevel") + 0.001 / skills.get("adaptationSkillLevel"));
        } else {
            increment = (100 * skills.get(action.skill)) / action.cost;
            skills.set(action.skill, skills.get(action.skill) + 0.001 / skills.get(action.skill));
        }

        actionBar.progressbar("value", val + increment);

        if (val < 100 - increment) {
            if (doubleTime > 0.1) {
                doubleTime -= 0.1;
                setTimeout(progress, 50);
            } else {
                setTimeout(progress, 100);
            }
        }
    }

    setTimeout(progress, 0);
}

function showDescription(x, y, text) {
    const descriptionBox = document.getElementById("description-box");
    const descriptionText = document.getElementById("description-text");

    document.addEventListener("mousemove", (e) => {
        // Get the mouse cursor's x and y coordinates
        const x = e.clientX;
        const y = e.clientY;

        // Position the tooltip near the mouse cursor
        descriptionBox.style.left = x + "px";
        descriptionBox.style.top = y + "px";
    });

    // Set the description text as HTML content
    descriptionText.innerHTML = text;

    // Show the description box
    descriptionBox.style.display = "block";
}

function hideDescription() {
    const descriptionBox = document.getElementById("description-box");
    descriptionBox.style.display = "none";
}


// Button click event handlers
// action buttons
document.getElementById("convertDroneButton").onclick = function () {
    handleButtonClick("convertDroneButton", repeatActionConvertDrone, "Drone", "Turn a prisoner into a drone. Drones contribute 0.20 to your follower's construction skill</br>Cost: 1 Prisoner, 1 Slime");
};

document.getElementById("drainWillButton").onclick = function () {
    handleButtonClick("drainWillButton", repeatActionDrainWill, "Drain will", "Sucks the will out of a prisoner, turning her into a mindless slave.</br>Mindless slaves contribute 0.05 to your follower's adaptation and construction skill</br>Cost: 1 prisoner, "+drainWillManaCost+" mana</br><span class=\"lore\"Even if their lack of enthusiasm makes them inefficient, seeing them carry out my orders without the slightest emotion is a delight.>");
};

document.getElementById("huntLoneHumanButton").onclick = function () {
    handleButtonClick("huntLoneHumanButton", repeatActionHuntLoneHuman, "Hunt", "Hunt insolated human</br>Time:"+Math.round(huntLoneHumanTime/getAdaptationSkillTotal())+"</br>Associated skill : AdaptationSkill</br>Requires empty cell");
};

document.getElementById("summonSlimeButton").onclick = function () {
    handleButtonClick("summonSlimeButton", repeatActionSummonSlime, "Slime", "Summon a slime</br>Mana Cost: "+Math.floor(slimeManaCost));
};

document.getElementById("meditateButton").onclick = function () {
    handleButtonClick("meditateButton", repeatActionMeditate, "Meditate", "Gather mana");
};

document.getElementById("slimeTrapButton").onclick = function () {
    handleButtonClick("slimeTrapButton", repeatActionCreateSlimeTrap, "Slime trap","Make a slime trap. Catch 1 enemy everytime you are attacked.</br>Cost: 1 slime");
};

document.getElementById("cellButton").onclick = function () {
    handleButtonClick("cellButton", repeatActionCreateCell, "Cell", "Make a cell to hold your prisoners");
};

document.getElementById("engraveWallButton").onclick = function () {
    handleButtonClick("engraveWallButton", repeatActionEngraveWall, "Engrave wall", "Engrave your dungeon's wall, increasing your mana capacity by 5%");
};
// upgrade buttons

// Add hover event listeners to the buttons
// action buttons
//TODO add "updatetooltips functions"

  document.getElementById("convertDroneButton").addEventListener("mouseover", function () {
    showDescription(this.getBoundingClientRect().right, this.getBoundingClientRect().bottom, "Turn a prisoner into a drone.</br>Drones contribute 0.20 to your follower's construction skill</br>Cost: 1 Prisoner, 1 Slime");
});

document.getElementById("convertDroneButton").addEventListener("mouseout", hideDescription);

document.getElementById("drainWillButton").addEventListener("mouseover", function () {
    showDescription(this.getBoundingClientRect().right, this.getBoundingClientRect().bottom, "Sucks the will out of a prisoner, turning her into a mindless slave.</br>Mindless slaves contribute 0.05 to your follower's adaptation and construction skill</br>Cost: 1 prisoner, "+drainWillManaCost+" mana</br><span class=\"lore\">Even if their lack of enthusiasm makes them inefficient, seeing them carry out my orders without the slightest emotion is a delight.</span>");
});
document.getElementById("drainWillButton").addEventListener("mouseout", hideDescription);

document.getElementById("huntLoneHumanButton").addEventListener("mouseover", function () {
    showDescription(this.getBoundingClientRect().right, this.getBoundingClientRect().bottom, "Hunt insolated human</br>Requires 1 empty cell");
});
document.getElementById("huntLoneHumanButton").addEventListener("mouseout", hideDescription);

document.getElementById("summonSlimeButton").addEventListener("mouseover", function () {
    showDescription(this.getBoundingClientRect().right, this.getBoundingClientRect().bottom, `Summon a Slime</br>Mana cost: ${Math.round(slimeManaCost)}</br><span class=\"lore\">Don't worry, they just want give you an everlasting hug!</span>`);
});
document.getElementById("summonSlimeButton").addEventListener("mouseout", hideDescription);

document.getElementById("meditateButton").addEventListener("mouseover", function () {
    showDescription(this.getBoundingClientRect().right, this.getBoundingClientRect().bottom, "Gather mana");
});
document.getElementById("meditateButton").addEventListener("mouseout", hideDescription);

document.getElementById("slimeTrapButton").addEventListener("mouseover", function () {
    showDescription(this.getBoundingClientRect().right, this.getBoundingClientRect().bottom,"Make a slime trap. catches  1 enemy everytime you are attacked.</br>Requires : 1 free slime</br>Consumes a slime each time it is activated");
});
document.getElementById("slimeTrapButton").addEventListener("mouseout", hideDescription);

document.getElementById("cellButton").addEventListener("mouseover", function () {
    showDescription(this.getBoundingClientRect().right, this.getBoundingClientRect().bottom, "Make a cell to hold your prisoners");
});
document.getElementById("cellButton").addEventListener("mouseout", hideDescription);

document.getElementById("engraveWallButton").addEventListener("mouseover", function () {
    showDescription(this.getBoundingClientRect().right, this.getBoundingClientRect().bottom, "Engrave your dungeon's wall, increasing your mana capacity by 5%");
});
document.getElementById("engraveWallButton").addEventListener("mouseout", hideDescription);

//upgrades buttons

document.getElementById("upgradeManaMaxButton").addEventListener("mouseover", function () {
  showDescription(this.getBoundingClientRect().right, this.getBoundingClientRect().bottom, `Spend all your mana to increase the maximum amount by 10</br>Mana cost: ${Math.round(manaMaxCost)}`);
});
document.getElementById("upgradeManaMaxButton").addEventListener("mouseout", hideDescription);

document.getElementById("upgradeWallEngravingButton").addEventListener("mouseover", function () {
  showDescription(this.getBoundingClientRect().right, this.getBoundingClientRect().bottom, "Inscribing runes in the walls of your dungeon will increase your mana reserves by 5%.</br>Mana cost: 40");//TODO
});
document.getElementById("upgradeWallEngravingButton").addEventListener("mouseout", hideDescription);

document.getElementById("upgradeTotalAssimilationButton").addEventListener("mouseover", function () {
  showDescription(this.getBoundingClientRect().right, this.getBoundingClientRect().bottom, "Allow your slimes to completely fuse with their host, making them able to change their shape.</br>You drones will contribute 0.05 to your follower's fighting skill.</br>Mana Cost : 50</br> <span class=\"lore\">You'd be ill-advised to underestimate them, although slow, their superhuman strength and tentacles mean that once they catch you, there's no escape.</span>")  ; 
});
document.getElementById("upgradeTotalAssimilationButton").addEventListener("mouseout", hideDescription);

document.getElementById("upgradeDrainWillButton").addEventListener("mouseover", function () {
  showDescription(this.getBoundingClientRect().right, this.getBoundingClientRect().bottom, "A spell that lets you to turn prisoners into mindless slaves.</br>Mana cost: 70</br><span class=\"lore\">Even if their lack of enthusiasm makes them inefficient, seeing them carry out my orders without the slightest emotion is a delight.</span>");
});
document.getElementById("upgradeDrainWillButton").addEventListener("mouseout", hideDescription);












/****************utils**************/
function getRandomDrone() {
    const assimilationLevel = upgrades.get("totalAssimilation");

    // Arrays of drone image strings based on the assimilation level
    const assimilation0Images = ["01.png", "02.png", "03.png"];
    const assimilationImages = ["01.png", "02.png", "03.png", "b01.png", "b02.png", "b03.png"];

    // Choose a random drone image string based on the assimilation level
    const imageArray = assimilationLevel === 0 ? assimilation0Images : assimilationImages;
    const randomIndex = Math.floor(Math.random() * imageArray.length);
    
    return imageArray[randomIndex];
}

function getRandomMindless() {

    const mindlessImages = ["01.png", "02.png"];
    const randomIndex = Math.floor(Math.random() * mindlessImages.length);
    
    return mindlessImages[randomIndex];
}



function calculateFibonacci(n) {
    if (n <= 1) {
        return n;
    }
    return calculateFibonacci(n - 1) + calculateFibonacci(n - 2);
}